Panda3D

Loading...
Searching...
No Matches
Public Member Functions | List of all members
ChecksumHashGenerator Class Reference

This is a specific kind of HashGenerator that simply adds up all of the ints. More...

`#include "checksumHashGenerator.h"`

Inheritance diagram for ChecksumHashGenerator:

## Public Member Functions
void | add_bool (bool flag)
| Adds a boolean flag.
void | add_fp (double num, double threshold)
| Adds a floating-point number, first converting it to fixed point by dividing it by the indicated threshold.
void | add_fp (float num, float threshold)
| Adds a floating-point number, first converting it to fixed point by dividing it by the indicated threshold.
void | add_int (long num)
| Adds another integer to the hash so far.
void | add_pointer (void *ptr)
| Adds a pointer, derived simply by casting the pointer to an integer.
void | add_string (const std::string &str)
| Adds a string to the hash, by breaking it down into a sequence of integers.
Public Member Functions inherited from HashGeneratorBase
size_t | get_hash () const
| Returns the hash number generated.

## Detailed Description

This is a specific kind of HashGenerator that simply adds up all of the ints.

Nothing fancy, and pretty quick.

Definition at line 25 of file checksumHashGenerator.h.

## Member Function Documentation

## ◆ add_bool()

void ChecksumHashGenerator::add_bool | ( | bool | flag | ) |
| inline

Adds a boolean flag.

Definition at line 35 of file checksumHashGenerator.I.

References add_int().

## ◆ add_fp() [1/2]

void ChecksumHashGenerator::add_fp | ( | double | num,
|  | double | threshold )
| inline

Adds a floating-point number, first converting it to fixed point by dividing it by the indicated threshold.

Definition at line 53 of file checksumHashGenerator.I.

References add_int().

## ◆ add_fp() [2/2]

void ChecksumHashGenerator::add_fp | ( | float | num,
|  | float | threshold )
| inline

Adds a floating-point number, first converting it to fixed point by dividing it by the indicated threshold.

Definition at line 44 of file checksumHashGenerator.I.

References add_int().

## ◆ add_int()

void ChecksumHashGenerator::add_int | ( | long | sum | ) |
| inline

Adds another integer to the hash so far.

This function should be overridden in base classes; this is the principle implementation of the HashGenerator.

Definition at line 27 of file checksumHashGenerator.I.

Referenced by add_bool(), add_fp(), add_fp(), add_pointer(), add_string(), BitArray::generate_hash(), and BitMask< WType, nbits >::generate_hash().

## ◆ add_pointer()

void ChecksumHashGenerator::add_pointer | ( | void * | ptr | ) |
| inline

Adds a pointer, derived simply by casting the pointer to an integer.

This should be good enough even on architectures for which this cast is lossy.

Definition at line 62 of file checksumHashGenerator.I.

References add_int().

## ◆ add_string()

void ChecksumHashGenerator::add_string | ( | const std::string & | str | ) |

Adds a string to the hash, by breaking it down into a sequence of integers.

Definition at line 19 of file checksumHashGenerator.cxx.

References add_int().

The documentation for this class was generated from the following files:

- panda/src/express/checksumHashGenerator.h
- panda/src/express/checksumHashGenerator.cxx
- panda/src/express/checksumHashGenerator.I